#include "data.h"
#include <algorithm>

CString GetSeznamStanic(const linky_t & linky)
{
	CString res = "<SeznamStanic>";
    
	std::map<CString, stanice_t>::const_iterator ci;
	for (ci = linky.stanice.begin(); ci != linky.stanice.end(); ci++) {
		res += "<Stanice>";
		res += ci->first;
		res += "</Stanice>";
	}

	res += "</SeznamStanic>";
	return res;
}

struct spojlinka_t
{
	CString linka, z, kam;
};

struct spojeni_t
{
	std::vector<spojlinka_t> linky;
};

struct findlink_t
{
	int maxspojeni;
	int maxprestupu;
	CString z, kam, pres;
	std::vector<spojeni_t> spojeni;
};

class sss : public std::binary_function<zastavka_t *, daytime_t, bool>
{
public:
	daytime_t cas;

	bool operator () (zastavka_t * a , zastavka_t * b) const
	{
		return timediff(a->odjezd, cas) < timediff(b->odjezd, cas);
	}
};

bool Browse(linky_t & l, findlink_t & fl, daytime_t cas, CString stanice, CString spoj, int depth, bool pres)
{
	if (l.stanice[stanice].depth != -1)
		return false;

	sss srt;
	srt.cas = cas;
	
	std::sort(l.stanice[stanice].zastavky.begin(), l.stanice[stanice].zastavky.end(), srt);
	
	l.stanice[stanice].depth = depth;
	for (size_t i = 0; i < l.stanice[stanice].zastavky.size(); i++) {
		
		if (l.stanice[stanice].zastavky[i]->odjezd != -1) {
			CString dalsi = l.linky[l.stanice[stanice].zastavky[i]->linka].GetNext(stanice);	
			if (Browse(l, fl, l.linky[l.stanice[stanice].zastavky[i]->linka].zastavkyName[dalsi]->prijezd,
				dalsi, l.stanice[stanice].zastavky[i]->linka,
				(spoj != l.stanice[stanice].zastavky[i]->linka)?depth + 1:depth, pres || stanice == fl.pres))
			{
				//....
			}
		}
	}
	l.stanice[stanice].depth = -1;
	return false;
}

CString GetNajdiSpojeni(linky_t & linky, std::map<CString, CString> & param)
{
	findlink_t fl;
	fl.z = param["odkud"];
	fl.kam = param["kam"];
	fl.pres = param["pres"];
	if (fl.pres.IsEmpty()) fl.pres = fl.z;
	fl.maxprestupu = atoi(param["prestupy"]);
	fl.maxspojeni = atoi(param["spojeni"]);
//	Browse(linky, fl, inet2daytime(param["odjezd"]), fl.z, "", 0, false);

	CString res = "<Spojeni>";
	res += "<Spoj>";
	res += "<Linka cislo=\"nestihl jsem...\">";

	res += "</Linka></Spoj>";
	res += "</Spojeni>";
	return res;
}
