#ifndef __DATA_H__
#define __DATA_H__

#include <map>
#include <string>
#include <vector>
#include <list>
#include <atlstr.h>

//typedef std::wstring CString;
typedef int daytime_t;

inline daytime_t str2daytime(CString str)
{
	int i, j;
	sscanf(str, "%2d:%2d", &i, &j);

	return i * 60 + j;
}

inline daytime_t inet2daytime(CString str)
{
	int i, j;
	sscanf(str, "%2d%2d", &i, &j);

	return i * 60 + j;
}

inline int timediff(daytime_t one, daytime_t two)
{
	int r = one - two;
	while (r < 0)
		r+=24*60;
	return r;
}

struct zastavka_t
{
	CString name;
	CString linka;
	daytime_t odjezd;
	daytime_t prijezd;
};

struct linka_t
{
	std::vector<zastavka_t *> zastavky;
	std::map<CString, zastavka_t *> zastavkyName;
	std::vector<CString> poznamky;

	CString GetNext(CString str)
	{
		size_t i;
		for (i = 0; i < zastavky.size(); i++) {
			if (zastavky[i]->name == str)
				break;
		}

		if (++i < zastavky.size())
			return zastavky[i]->name;

		return "";
	}
};

struct stanice_t
{
	std::vector<zastavka_t *> zastavky;

	// link search...
	int depth;
};

struct linky_t
{
	// cislo linky -> linka
	std::map<CString, linka_t> linky;

	// jmeno stanice -> stanice
	std::map<CString, stanice_t> stanice;

	std::list<zastavka_t> zastavky;

	bool empty() const
	{
		return linky.empty();
	}
};

CString GetSeznamStanic(const linky_t & linky);
CString GetNajdiSpojeni(linky_t & linky, std::map<CString, CString> & param);

#endif
