/*
  Aby bylo jasno, vas f*cking C++Builder nema XMLDocument a ani ho neumi importovat
  ze systemu. Protoze nemohu pouzivat libxml2 ani expat, pisu vlastni parser,
  coz ovsem neznamena, ze si nejsem vedom existence systemoveho xml parseru...
*/

#include "parsedata.h"

CParseData::CParseData(linky_t & linky)
: m_linky(linky)
{

}

void CParseData::Load(CString filename)
{
	FILE * fin = fopen(filename, "rb");
	if (!fin) {
		printf("Failed to load source file..\n");
		return;
	}

	fseek(fin, 0, SEEK_END);
	size_t s = ftell(fin);
	fseek(fin, 0, SEEK_SET);

	char * buff = new char [s];
	fread(buff, 1, s, fin);
	Parse(buff);
	delete[] buff;

	fclose(fin);
}

#define WHITESPACE ' ': case '\n': case '\r': case '\t'
void CParseData::Parse(const char * xml)
{
	printf("Loading xml, hang on...");

	const char * curpos = xml;
	int state = 0;

	CString buff, attrkey;

	for (; *curpos != 0 && state >= 0; curpos++) {
		switch (state)
		{
		case 0: // whitespace
			switch (*curpos)
			{
			case '<':
				state = 1;
				HasText(buff);
				break;
			default:
				buff += *curpos;
			}
			break;
		case 1: // waiting for elem name
			switch (*curpos)
			{
			case WHITESPACE:
				break;
			default:
				buff = *curpos;
				state = 2;
				break;
			}
			break;
		case 2: // in elem name
			switch (*curpos)
			{
			case WHITESPACE:
				HasElement(buff);
				state = 3;
				break;
			case '>':
				HasElement(buff);
				state = 0;
				buff.Empty();
				break;
			default:
				buff += *curpos;
				break;
			}
			break;
		case 3: // waiting for attr
			switch (*curpos)
			{
			case WHITESPACE:
				break;
			case '>':
				state = 0;
				buff.Empty();
				break;
			default:
				buff = *curpos;
				state = 4;
				break;
			}
			break;
		case 4: // in attr key
			switch (*curpos)
			{
			case WHITESPACE:
				attrkey = buff;
				state = 5;
				break;
			case '=':
				attrkey = buff;
				state = 6;
				break;
			default:
				buff += *curpos;
				break;
			}
			break;
		case 5: // waiting "="
			switch (*curpos)
			{
			case '=':
				state = 6;
				break;
			}
			break;
		case 6: // waiting for quotes
			switch (*curpos)
			{
			case '"':
				buff.Empty();
				state = 7;
				break;
			}
			break;
		case 7: // in attr value
			switch (*curpos)
			{
			case '"':
				HasAttribute(attrkey, buff);
				state = 3;
				break;
			default:
				buff += *curpos;
				break;
			}
		}
	}
	printf("OK\n");
}

void CParseData::DefaultParse()
{
	if (m_linky.empty())
		Load("data.xml");
}

void CParseData::HasText(CString text) 
{
	if (m_elem == "Stanice")
		zastavka.name = text;

	if (m_elem == "Poznamka")
		m_linky.linky[linka].poznamky.push_back(text);
}

void CParseData::HasElement(CString elem)
{
	m_elem = elem;
	if (elem == "Stanice") {
		zastavka.linka = linka;
		zastavka.odjezd = -1;
		zastavka.prijezd = -1;
	}

	if (elem == "/Stanice") {
		if (zastavka.prijezd == -1)
			zastavka.odjezd = zastavka.prijezd;
		m_linky.zastavky.push_back(zastavka);
		m_linky.linky[linka].zastavky.push_back(&m_linky.zastavky.back());
		m_linky.stanice[zastavka.name].zastavky.push_back(&m_linky.zastavky.back());
		m_linky.stanice[zastavka.name].depth = -1;
	}
}

void CParseData::HasAttribute(CString key, CString value)
{
	if (m_elem == "Linka")
		if (key == "cislo")
			linka = value;

	if (m_elem == "Stanice") {
		if (key == "odjezd")
			zastavka.odjezd = str2daytime(value);
		if (key == "prijezd")
			zastavka.prijezd = str2daytime(value);
	}
}
