#include <winsock2.h>
#include <windows.h>

#include "data.h"
#include "parsedata.h"

linky_t g_linky;
short g_port = 80;

void Transmit(SOCKET s, CString str)
{
	int len = 0;
	while (len < str.GetLength()) {
		int sent = send(s, (const char *) str + len, str.GetLength() - len, 0);
		if (sent == SOCKET_ERROR)
			return;
		len += sent;
	}
}

void Run(SOCKET s, CString url, std::map<CString, CString> & param)
{
	CString response = "<Chyba>Neznamy pozadavek. Nebude zpracovan.</Chyba>";
	
	if (url == "/SeznamStanic")
		response = GetSeznamStanic(g_linky);

	if (url == "/NajdiSpojeni")
		response = GetNajdiSpojeni(g_linky, param);

	Transmit(s, "HTTP/1.0 200 OK\r\n");
	Transmit(s, "Content-type: text/xml\r\n");
	Transmit(s, "\r\n");
	Transmit(s, response);

	shutdown(s, SD_BOTH);
}

DWORD CALLBACK NetThr(LPVOID)
{
	WSADATA wd;
	WSAStartup(MAKEWORD(2, 2), &wd);

	// Create the listener....
	SOCKET sockListen = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	
	sockaddr_in addr;
	memset(&addr, 0, sizeof addr);
	addr.sin_family = AF_INET;
	addr.sin_port = htons(g_port);
	bind(sockListen, (const sockaddr *) &addr, sizeof addr);

	listen(sockListen, SOMAXCONN);

	for(;;) {
		SOCKET sockClient = accept(sockListen, NULL, NULL);
		if (sockClient == INVALID_SOCKET)
			break;

		// Command data...
		bool hasCommand = false;
		CString url;
		std::map<CString, CString> parametry;
		
		// Receive a request...
		char line[1024];
		int len = 0;

		char lastload[1024];
		lastload[0] = 0;
		for (; len != -1;) {
			len = 0;
			for (bool done = false; !done;) {
				
				char tmp[1024];
				char req[1024];
				int read = 0;
				
				if (!strchr(lastload, '\n')) {
					read = recv(sockClient, tmp, 1024, 0);
					if (read == 0 || read == SOCKET_ERROR) {
						len = -1;
						closesocket(sockClient);
						break;
					}
				}

				tmp[read] = 0;
				strcpy(req, lastload);
				strcat(req, tmp);

				for (int i = 0; req[i] != 0; i++) {
					if (req[i] == '\r') continue;
					if (req[i] == '\n') {
						i++;
						line[len] = 0;
						done = true;
						break;
					}

					line[len++] = req[i];
				}

				strcpy(lastload, req + i);
			}

			if (len == -1) break;

			if (line[0] == 0) {
				if (hasCommand)
					Run(sockClient, url, parametry);
				continue;
			}
			
			if (line[3] != 0) {
				line[3] = 0;
				if (strcmp(line, "GET") == 0) {
					hasCommand = true;
					int i;
					for (i = 4; line[i] != 0 && line[i] != ' ' && line[i] != '?'; i++)
						url += line[i];

					if (line[i] == '?') {
						

						CString key, value;
						int state = 0;

						for (i++; line[i] != 0 && line[i] != ' '; i++) {
							switch(state)
							{
							case 0:
								switch (line[i])
								{
								case '=': state = 1; break;
								case '&': state = 2; break;
								default:
									key += line[i];
								}
								break;
							case 1:
								switch (line[i])
								{
								case '&': state = 2; break;
								case '+': value += ' '; break;
								default:
									value += line[i];
								}
								break;
							}
							
							if (state == 2) {
								state = 0;
								parametry[key] = value;
								key.Empty();
								value.Empty();
							}
						}
					}
				}
			}

//			printf("%s\n", line);
		}
	}

    closesocket(sockListen);
	return 0;
}

void PrintParams()
{
	printf("server [-l <data.xml>] [-p <port>]\n");
}

int main(int argc, char * argv[])
{
	printf("Server...\n"
		"Type `quit` to finish.\n");
	
	CParseData parser(g_linky);
	
	for (int i = 1; i < argc; i++) {
		if (!strcmp(argv[i], "-l")) {
			if (!argv[++i]) {
				PrintParams();
				return 1;
			}

			parser.Load(argv[i]);
			continue;
		}

		if (!strcmp(argv[i], "-p")) {
			if (!argv[++i]) {
				PrintParams();
				return 1;
			}

			g_port = atoi(argv[i]);
			if (g_port == 0) {
				PrintParams();
				return 1;
			}
			continue;
		}

		PrintParams();
		return 1;
	}

	parser.DefaultParse();

	if (g_linky.empty())
		return 2;

	HANDLE hNetThread = CreateThread(NULL, 0, &NetThr, NULL, 0, NULL);

	for (;;) {
		char tmp[128];
		printf("> ");
		gets(tmp);

		if (strcmp(tmp, "quit") == 0)
			break;
	}

	WSACleanup();

	WaitForSingleObject(hNetThread, INFINITE);
	CloseHandle(hNetThread);
	
	return 0;
}
